#include "routecalc.h"
#include <cmath>
#include <iostream>
#include <fstream>

using namespace std;

//Maths Constants <<<Seems to already have a Pi that i can't use...>>>
float Pie = 3.141592654;

//Help File
void HelpFile(){
     cout<<"\nRoute Trajectory Calculator\n"
     <<"--------------------------------------------\n"
     <<"Calculates Required Heading for Given Cruise Speed\n"
     <<"as Affected by Wind Speed and Direction\n"
     <<"Calculates E.T.A. and Fuel Requirements\n"
     <<"\nINPUT UNITS:\n\n"
     <<" Time -------- HH:MM\n"
     <<" Angle ------- Degrees Decimal\n"
     <<" Distance ---- Arbitrary Decimal\n"
     <<" Speed ------- Decimal Distance units per Hour\n"
     <<" Consumption - Decimal Arbitrary Units per Hour\n"
     <<endl;
     exit(0);     
}

//Converts Angles
float Radians(float Deg){      
      return ((Deg / 360.0) * (Pie * 2));
}

float Degrees(float Rad){
      return ((Rad /(2 * Pie)) * 360);          
}

//Class RouteCalc
//Constructors
RouteCalc::RouteCalc(){
           cout<<"\nRequired Bearing: ";
           cin>>RB;
           cout<<"\nCruising Speed: ";
           cin>>CS;
           cout<<"\nWind (BRG/V): ";
           char Arb;
           cin>>WB>>Arb>>WS;          
}

RouteCalc::RouteCalc(float RB, float CS, float WB, float WS){
          RouteCalc::RB = RB;
          RouteCalc::CS = CS;
          RouteCalc::WB = WB;
          RouteCalc::WS = WS;                
}


RouteCalc GetRoute(){
          float RB, CS, WB, WS;
         cout<<"\nRequired Bearing: - ";
           cin>>RB;
           cout<<"Cruising Speed: --- ";
           cin>>CS;
           cout<<"Wind Bearing: ----- ";
           cin>>WB;
           cout<<"Wind Speed: ------- ";
           cin>>WS; 
          RouteCalc Route(RB, CS, WB, WS);
          return Route;
}

//Does the Vector Calculation
void CalcRoute(RouteCalc Route, float &BRG, float &SPD){
     //  <<<uses Sin(a)/A = Constant rule if BRG != WB or WB - 180>>>
     float AConst = (sin(Radians(fabs(Route.RB - Route.WB)))/Route.CS);
     float BAngle = Degrees(asin(AConst * Route.WS));
     float CAngle = 180 - (BAngle + fabs(Route.RB - Route.WB));
     float CLength = (sin(Radians(CAngle)) / AConst);
     
     if(QuadFix(Route.RB) != QuadFix(Route.WB)){

     float K1 = Route.RB;
     float K2 = Route.WB;
     
     //    <<<TEST SPACE>>>
     
     //    <<<End Test Space
     
     BRG = CircFix(Route.RB + fabs(BAngle) * Sign(K1,K2));     
     SPD = CLength;   
       
     }
     else{
          BRG = Route.RB;
          if (BRG == Route.WB){
               SPD = Route.CS + Route.WS;
          }
          else {
               SPD = Route.CS - Route.WS;
          }
     }
     return;
}

//Keeps Circles 0 - 369 deg
float CircFix(float Angle){
      if(Angle > 360){
               return Angle - 360;
               }      
      if(Angle < 0){
               return Angle + 360;
               }
      return Angle;      
}

//Gets a Sign for +/-
int Sign(float K1, float K2){
    if (fabs(K1 - K2) > 180){
    return int(K2 - K1)/int(fabs(K2 - K1)); 
    }
    else{
    return int(K1 - K2)/int(fabs(K1 - K2));      
    }    
}

//Try Again.. Returns Angle in 1st 2 quadrants
float QuadFix(float Angle){
      return fmod(Angle,180);
}

//Calculates Fuel Consumption
float Consumption(float SPD, float DIST, float &TIME){
      float Flow;
      cout<<"Fuel Consumption (Units/Hour): ";
      cin>>Flow;
      TIME = DIST / SPD;
      return (Flow * TIME);   
}

//Calculates Time in Hours and Minutes
void TimeCalc(float TIME, int &HR2, int &MI2, int HRS, int MIN){
     float Minutes1 = TIME * 60;
     float Minutes2 = MIN + (HRS * 60);
     float Minutes3 = Minutes1 + Minutes2;
     
     HR2 = int(fmod(floor(Minutes3 / 60),24));
     MI2 = int(fmod(Minutes3, 60));
     return;     
}

